<%-- $Id: close_popup.jsp 6607 2014-11-19 14:52:20Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	Closes a popup window.

	@param message
		A message to display before the popup is closed. If not
		specified the value "Settings saved" are used.

	@param title
		The title of the page.

	@param wait
		Milliseconds to wait before the popup is closed. If not
		specified 1200 is used.

	@param redirect_opener
		If specified the window that opened the popup will be redirected
		to this URL. 

	@param refresh_opener
		If specified with a non-zero value the window that opened
		the popup will be reloaded. Ignored if redirect_opener is 
		specified.
		
	@param notify_opener
		If specified an custom event is sent to the opener window.

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
String message = Values.getString(request.getParameter("message"),"");
String title = Values.getString(request.getParameter("title"), message);
int millisecondsToWait = Values.getInt(request.getParameter("wait"), 1200);
String redirectOpener = request.getParameter("redirect_opener");
boolean refreshOpener = Values.getBoolean(request.getParameter("refresh_opener"));
String notifyOpener = request.getParameter("notify_opener");
%>
<base:page type="popup" title="<%=title%>">
<base:head scripts="~close_popup.js" />
<base:body data-no-dialog-position="1">
	<div id="page-data" class="datacontainer"
		data-wait="<%=millisecondsToWait%>" 
		data-refresh-opener="<%=refreshOpener ? "1" : "0" %>"
		data-redirect-opener="<%=HTML.encodeTags(redirectOpener)%>"
		data-notify-opener="<%=HTML.encodeTags(notifyOpener)%>"
		></div>
	<h1><%=title%></h1>
	<div class="content">
		<table class="fullcc bg-filled-50 bottomborder"><tr><td>
		<b><%=message%></b>
		</td></tr></table>
	</div>
</base:body>
</base:page>
