<%-- $Id: list.jsp 7982 2021-06-14 08:01:21Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Johan Enell, Nicklas Nordborg
	Copyright (C) 2007 Johan Enell

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@page import="net.sf.basedb.clients.web.ModeInfo"%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.ExtendedProperty"
	import="net.sf.basedb.core.DynamicReporterQuery"
	import="net.sf.basedb.core.DynamicResultIterator"
	import="net.sf.basedb.core.VirtualColumn"
	import="net.sf.basedb.core.data.ReporterData"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Dynamic"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Selects"
	import="net.sf.basedb.core.query.Aggregations"
	import="net.sf.basedb.core.query.JoinType"
	import="net.sf.basedb.core.query.SqlResult"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.DynamicUtil"
	import="net.sf.basedb.clients.web.ExperimentExplorer"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.taglib.table.TableColumn"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.HashMap"
	import="java.util.List"
	import="java.util.LinkedList"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%!
	private static final Item itemType = Item.REPORTER;
%>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String root = request.getContextPath();
final ModeInfo mode = ModeInfo.DEFAULT;

final int bioAssaySetId = Values.getInt(request.getParameter("bioassayset_id"));
final DbControl dc = sc.newDbControl(":Experiment explorer - Search");
DynamicResultIterator reporters = null;
long totalReporters = 0;
try
{
	String title = null;
	final BioAssaySet bioAssaySet = BioAssaySet.getById(dc, bioAssaySetId);
	final Experiment experiment = bioAssaySet.getExperiment();
	final RawDataType rawDataType = experiment.getRawDataType();
	
	final ExperimentExplorer explorer = ExperimentExplorer.getExplorer(bioAssaySet);
	final ItemContext cc = explorer.getAndSetReporterContext(sc, null);
	final String subContext = cc.getSubContext();

	List<TableColumn> allColumns = new LinkedList<TableColumn>();
	DynamicUtil.addReporterColumns(allColumns, dc, experiment.getVirtualDb().getReporterCloneTemplate(), "", "@", "");
	
	DynamicUtil.SelectedInfo selected = DynamicUtil.getSelectedColumns(cc, allColumns, false);
	List<TableColumn> selectedColumns = selected.selectedColumns;
	
	try
	{
		DynamicReporterQuery reporterQuery = explorer.getReporterQuery(dc, selected.selectedProperties);
		reporterQuery.setFailSafe(true);
		totalReporters = explorer.getMatchingReporters(dc);
		reporters = reporterQuery.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
		t.printStackTrace();
	}
	int numListed = 0;
	%>
	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol-2.js,~list.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
	<style>
		.row-index > div
		{
			grid-template-columns: 1fr !important;
		}
		.row-index .index
		{
			padding-right: 3px;
		}
	</style
	</base:head>
	<base:body>
		<p:path><p:pathelement
			title="Experiments" href="<%="../../index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(experiment.getName())%>" 
				href="<%="../../bioassaysets/index.jsp?ID="+ID+"&amp;experiment_id="+experiment.getId()%>" 
			/><p:pathelement title="<%=HTML.encodeTags(bioAssaySet.getName())%>" 
				href="<%="../../bioassaysets/index.jsp?ID="+ID+"&amp;cmd=ViewItem&amp;item_id="+bioAssaySetId%>" 
			/><p:pathelement title="Explorer" /></p:path>
		<t:tabcontrol 
			id="explorer"
			subclass="mastertabcontrol content"
			remember="false" active="search">
		<t:tab id="search" title="Reporter search">
		<tbl:table 
			id="reporters" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subcontext="<%=subContext%>"
			filterrows="<%=cc.getFilterRows()%>"
			subclass="fulltable"
			stickyheaders="<%=cc.getSetting("columns.sticky", "externalId")%>"
			>
			<tbl:hidden 
				name="bioassayset_id" 
				value="<%=String.valueOf(bioAssaySetId)%>" 
			/>
			<%
			for (TableColumn tc : allColumns)
			{
				%>
				<tbl:columndef
					id="<%=tc.getId()%>"
					clazz="<%="externalId".equals(tc.getId()) ? "uniquecol" : "columnheader"%>"
					property="<%=tc.getProperty()%>"
					datatype="<%=tc.getDatatype().getStringValue()%>"
					title="<%=tc.getTitle()%>"
					sortable="<%=tc.getSortable()%>"
					filterable="<%=tc.getFilterable()%>"
					exportable="<%=tc.getExportable()%>"
					show="<%=tc.getShow()%>"
					formatter="<%=tc.getFormatter()%>"
				/>
				<%
			}
			%>
			<tbl:columndef 
				id="reporterList"
				property="£reporterList"
				datatype="int"
				title="Reporter list"
				filterable="true"
				enumeration="<%=Base.getReporterListsEnum(dc)%>"
				multiple="false"
			/>			
			
			<div class="panelgroup bg-filled-50 bottomborder">
				<tbl:toolbar subclass="bottomborder">
					<tbl:button 
						id="btnColumns"
						image="columns.png" 
						title="Columns&hellip;" 
						tooltip="Show, hide and re-order columns" 
					/>
					<tbl:button
						id="btnNewReporterList"
						image="add.png"
						title="New reporter list&hellip;"
						tooltip="Create a new reporter list from matching reporters"
						visible="<%=sc.hasPermission(Permission.CREATE, Item.REPORTERLIST)%>"
					/>
				</tbl:toolbar>
				<tbl:panel>
					<tbl:presetselector />
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=totalReporters%>" 
					/>
				</tbl:panel>
			</div>
			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header clazz="row-index bg-filled-100" />
						<tbl:columnheaders />
					</tbl:headerrow>
					<%
					int numFilters = cc.getNumPropertyFilters();
					int numRows = cc.getFilterRows();
					for (int filterNo = 0; filterNo < numRows; filterNo++)
					{
						boolean lastRow = filterNo == numRows-1;
						%>
						<tbl:headerrow>
							<tbl:header subclass="row-index bg-filled-100">
								<div class="index-<%=mode.getName()%>">
									<div class="icons">
										<base:icon
											subclass="link table-filter-row-action"
											image="add.png"
											tooltip="Add extra filter row"
											visible="<%=lastRow%>"
										/><base:icon
											subclass="link table-filter-row-action"
											image="remove.png"
											tooltip="Remove this filter row"
											visible="<%=numRows > 1 || numFilters > 0 %>"
											data-remove-row="<%=filterNo%>"
										/>
									</div>
								</div>
							</tbl:header>

							<tbl:propertyfilter row="<%=filterNo%>" />
						</tbl:headerrow>
						<%
					}
					%>
				</tbl:headers>
				<tbl:rows>
			<%
			if (cc.getMessage() != null)
			{
				%>
				<tbl:panel subclass="bg-filled-50">
					<div class="messagecontainer error"><%=cc.getMessage()%></div>
				</tbl:panel>
				<%
				cc.setMessage(null);
			}
			int rowIndex = cc.getPage()*cc.getRowsPerPage();
			if (reporters != null)
			{
				boolean writeReporterPermission = sc.hasPermission(Permission.WRITE, Item.REPORTER);
				String tooltip = "View this item" + (writeReporterPermission ? " (use CTRL, ALT or SHIFT to edit)" : "");
				while (reporters.hasNext())
				{
					SqlResult item = reporters.next();
					int itemId = item.getInt(1);
					rowIndex++;
					numListed++;
					%>
					<tbl:row>
						<tbl:header clazz="row-index bg-filled-100">
							<div class="index-<%=mode.getName()%>">
								<div class="index <%=rowIndex>999?"index-smaller":""%>"><span class="link auto-init" 
								data-auto-init="view-reporter"
								data-index="<%=rowIndex-1%>"><%=rowIndex%></span></div>
							</div>
						</tbl:header>
						<%
						int colIndex = 2;
						for (TableColumn tc : selectedColumns)
						{
							String name = tc.getId();
							if ("externalId".equals(name))
							{
								%>
								<tbl:cell column="externalId"><div 
									class="link table-item"
									data-item-id="<%=itemId%>"
									data-no-edit="<%=writeReporterPermission ? 0 : 1%>"
									tabindex="0"
									title="<%=tooltip%>"><%=HTML.encodeTags(item.getString(colIndex))%></div></tbl:cell>
								<%
							}
							else
							{
								%>
								<tbl:cell column="<%=name%>"><tbl:cellvalue value="<%=item.getObject(colIndex)%>" /></tbl:cell>
								<%
							}
							colIndex++;
						}
						%>
					</tbl:row>
					<%
				}
			}
			if (numListed == 0)
			{
				%>
				<tbl:panel subclass="bg-filled-50">
					<div class="messagecontainer note">
					<%=totalReporters == 0 ? "No reporters were found" : "No reporters on this page. Please select another page!" %>
					</div>
				</tbl:panel>
				<%
			}
			%>
			</tbl:rows>
			</tbl:data>
			</tbl:table>
		</t:tab>

		<t:tab id="view" title="Reporter view" />
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (reporters != null) reporters.close();
	if (dc != null) dc.close();
}

%>
